# HUE LightShow

## Motivation

For the gender reveal of my second kid, I wanted to do something unique and fun. It was the perfect excuse to justify the purchase of a Philips Hue Lightstrip to the Mrs.

I wrapped the light strip around our Christmas tree and wrote some Javascipt to alternate between blue and pink. There were a couple iterations.

## Technical Details

`lib.js` contains some helper functions (and authentication to the Hue Bridge) that leverage the Philips Hue REST API. These functions are used in `main.js` to control the light strip.

The first iteration of the light show was a simple alternating sequence that loaded all the color transitions into the event loop at the start with the setTimeout progressively having a longer delay to create the sequence.

The linear nature was a bit boring, so I pulled in a [bezier.js library](https://github.com/Pomax/bezierjs/blob/master/src/utils.js) (Thank you [Pomax](https://github.com/Pomax)) to create a more dynamic pacing of the sequence.

Following the same setTimeout strategy, I created a list of values from the bezier curve to use as the root of the setTimeout delay making the sequence speed up and then slow down to a stop. Once the sequence was complete, the final color would start to glow in and out.

## Video

Here is the final product. Please be aware, the video contains rapid flashes near the beginning. If you are sensitive to flashing lights and still want to watch it, consider skipping to the middle of the video where the sequence slows down considerably.

[![HUE Light Show](https://img.youtube.com/vi/1Q2J9zv3Q1Y/0.jpg)](https://photos.app.goo.gl/Qst3tRiBQrFXAEuZ6)
